#
# Copyright (C) 2010-2016 dtk contributors
#
# This file is part of the dtk project.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

require 'yaml'
module DTK::Client
  class Render
    class Simple < self

      def render(data, _opts = {})
        if data.kind_of?(Hash) or data.kind_of?(Array)
          render_text(::DTK::DSL::YamlHelper.generate(data)) unless data.empty?
        end
      end

      private

      def initialize(render_type, _opts = {})
        super(render_type)
      end

    end
  end
end
